/*
 * Output plus main storage class for password and task information
 * 
 * Copyright (C) 2017 Vojtech Vecera
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the r  ghts 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE.
 */

#include "control.h"

void Control::set_boinc(int argc, char** argv){
    if (argc == 2 && argv[1][0] =='-' && argv[1][1] == 'b')
	this->boinc = false;
    else if (argc == 1)
	this->boinc = true;
    else {
	std::cerr << "Invalid number of arguments!" << std::endl;
	std::cout << "Usage: runnerXX.YYY [-b] \n -b - optional parameter setting runneru to run with boinc client else it is standalone \n\n XX - is either '32' or '64' based on architecture of system\n YYY - is extension where 'bin' is for UNIX based systems and 'exe' for Windows" << std::endl;
    }
}

std::string Control::generate_output_content() {
    //std::cerr << __FILE__ << " " << __LINE__ << std::endl;
    std::string result = "";

    /**
     * @brief Benchmark type
     */
    if(this->taskParams.mode == "b") {
        if(this->exitCode == 1)
            result = "b\n0\n" + std::to_string(this->avgSpeed) + "\n" + this->totalTime + "\n";
        else
            result = "b\n3\n" + std::to_string(this->exitCode) + "\n" + this->errorText + "\n";
    }

    /**
     * @brief Normal attack
     */
    else if(this->taskParams.mode == "n"){
        //if(this->errorText.length()) {
        //    result = "n\n2\n" + this->errorText + "\n";
        //}
        if(this->exitCode == 0) 
	    result = "n\n0\n" + r_base64_encode(this->password.c_str(), this->password.length()) + "\n" + this->totalTime + "\n";
	else if (this->exitCode == 1)
	    result = "n\n1\n" + this->totalTime + "\n";
	else
	    result = "n\n3\n" + std::to_string(this->exitCode) + "\n" + this->errorText + "\n";
    }

    return result;
}

void Control::create_output_file(bool boinc) {
    //std::cerr << "control.cpp:" << __LINE__ << std::endl;
    std::string content = generate_output_content();
    if(boinc) {
        char buf[256];
        open_output("out", this->out);
        this->out.printf("%s",content.c_str());
        int retval = this->out.flush();
        if (retval) {
	    std::cerr << boinc_msg_prefix(buf, sizeof(buf)) << " APP: upper_case flush failed " << retval << std::endl;
            boinc_finish(1);
        }
    }
    //std::cerr << "control.cpp:" << __LINE__ << std::endl;
    std::cerr << content << std::endl;
}
