/*
 * Copyright (C) 2017 Vojtech Vecera
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE.
 */

#ifndef CONTROL_H
#define CONTROL_H

#include <iostream>
#include <sstream>
#include "boinc_api.h"

#include "resolver.h"
#include "base64.h"

#define PATH_SIZE 512
#define BUFFER_SIZE 256

typedef struct taskParams{
    std::string attack_mode; // 0, 1, 3, 6, 7, 9
    std::string mode;	/// Cracking mode b-benchmark, n-normal, v-verify, u-unknown.
    std::string hash_type;	/// Cracking mode b-benchmark, n-normal, v-verify, u-unknown.
    std::string skip; /// Number of first password permutation.
    std::string limit;	/// Number of last password permutation.
    std::string name;
    std::string mask;
    std::string charset1;    /// Charset of the task.
    std::string charset2;    /// Charset of the task.
    std::string charset3;    /// Charset of the task.
    std::string charset4;    /// Charset of the task.
    std::string passlen_min;
    std::string passlen_max;

    uint64_t start = 0;
    uint64_t end = 0;
    bool dictionary1 = false;
    bool dictionary2 = false;

    std::string password;   /// Password if we have found one.
} TTaskParams;

class Control {

    MFILE out;
    bool boinc = false;
    bool passwordFound = false;

    uint32_t counter = -1;

    //float lastBoincFractionDone = 0.0; /// Percetanges of how much of the task is done

    std::string totalTime = "0";

    public:
	std::string errorText = "no code";
	unsigned long long avgSpeed = 0;
	long unsigned exitCode;
	TTaskParams taskParams;
	std::string password = "Not found";

	void create_output_file(bool boinc);

	void set_boinc(int argc, char** argv);
	void set_avgspeed(int as) {this->avgSpeed = as;}
	void set_totaltime(std::string tt) {this->totalTime = tt;}

	std::string get_totaltime() {return this->totalTime;}
	bool get_boinc() const {return this->boinc;}
	//int  get_exitcode() const {return this->exitCode;}

	//TTaskParams& get_task_params() {return this->taskParams;}

    private:
	std::string generate_output_content();
};
#endif // CONTROL_H
