/*
 * Copyright (C) 2016 - 2017 Radek Hranicky, Vojtech Vecera
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE.
 */

#ifndef MAIN_H
#define MAIN_H

#if defined (__linux__)
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <limits.h>
#include <dirent.h> 
#include <fcntl.h>
#include <zip.h>
#elif defined (__MINGW64__) || defined (__MINGW32__) || defined (_WIN32) || defined (_WIN64)
#undef _GLIBCXX_HAS_GTHREADS
#define ZIP_STATIC
#include <windows.h>
#include "zip.h"
//#define __USE_MINGW_ANSI_STDIO 0
#include "mingw.thread.h"
//#include "mingw.mutex.h"
//#include "mingw.condition_variable.h"
#endif
#include <iostream>
#include <string>
#include <fstream>
#include <iterator>
#include <thread>
#include <vector>
#include <cstdlib>
#include <cstring>
#include <cerrno>
//#include <condition_variable>
#include "boinc_api.h"

#include "resolver.h"
#include "control.h"
#include "parser.h"

void launch_hashcat();
void prepare_args(std::vector<char*>& args, std::string& name);

void create_process();
bool file_exists(const std::string& name);
int zip_extract(const char *archive);
static void safe_create_dir(const char* dir);

void test_local_config(std::string dirPath, std::string filePath);
#endif // MAIN_H
